function [b_out, a_out] = PLS_est(N, T, K, b0, y, X, M, lambda, R, tol)


    pen  = ones(N, M);
    b_out  = repmat(b0, [ 1 1 M]);
    a_out  = zeros(M, K);

    b_old = ones(N, K);
    a_old = zeros(1, K);

    cvx_quiet(true)
        
        %maximum amount of iterations
        for r = 1:R
            for m = 1:M


                for mm = setdiff(1:M, m)
                    pen(:, mm) =  norms( bsxfun(@minus, b_out(:, :, mm), a_out(mm, :) ), 2, 2 );
                end
                pen(:,m) = ones(N, 1);
                penalty_out  =  prod(pen, 2);
                   
                %minimize the ppl function
                cvx_begin
                    variable b(N, K)
                    variable a(1, K);
                    B1 = kron( b, ones(T,1) );
                    Q =  1/(N*T) * sum_square(  y - sum(X .* B1, 2) );


                    pen_m = norms(  b - repmat(a, N, 1), 2, 2 );
                    penalty =  penalty_out' * pen_m ;


                    minimize( Q  + lambda/N *  penalty);
              
                cvx_end

                pen(:,m) = pen_m;
                
                %for each m, a different group of individuals converge
                b_out(:, :, m) = b;
                a_out(m, :) = a;

            end



            b_new = b_out(:, :, m);
            a_new = a_out(m, :);

            %when the criterion is reached, break out of loop for max
            %amount of iterations
            if criterion( a_old, a_new, b_old, b_new, tol  ) == 1
                break;
            end


            a_old = a_out(m, :);
            b_old = b_out(:, :, m);

        end
    end
