function [d] = criterion( a_old, a_new, b_old, b_new, tol)
% Liangjun Su, Zhentao Shi, Peter Phillips (2014)
% the convergence criterion of the algorithm

% INPUT
%   a_old: a in the previous round
%   a_new: a in the current round
%   b_old: b in the previous round
%   b_new: b in the current round
%   tol: tolerenace level

% OUPUT
%   d: a dummy variable. d = 1 indicates "converged". Otherise d = 0

    d = 0;
    a_nominator = sum( abs( a_old - a_new ) );
    a_denominator = sum( abs( a_old ) ) + 0.001;
    
    b_nominator = mean( abs( b_old - b_new ) );
    b_denominator = mean( abs( b_old ) ) + 0.001;
    
    b_nominator / b_denominator;
    
    %%
    if a_nominator/ a_denominator < tol &&  b_nominator / b_denominator < tol
        d = 1;
    end

end