function [SSR] = ssr_break(y,x,reg_mem)
% This function computes the overall sum of squared residuals 
% given the regime and sub-sample
% 
% Output:
% SSR
K           = size(x,3);
N           = size(x,2);
reg_mem     = reg_mem(:,find(sum(reg_mem)));
num_bk      = size(reg_mem,2);
SSR         = 0;
for i = 1:num_bk
    sample  = find(reg_mem(:,i) == 1); 
    samp_ry = y(sample,:);
    samp_rx = x(sample,:,:);
    samp_y  = reshape(samp_ry,N*length(sample),1);        
    samp_x  = reshape(samp_rx,N*length(sample),K);    
    samp_b  = (samp_x'*samp_x)\(samp_x'*samp_y);
    sub_ssr = sum((samp_y-samp_x*samp_b).^2);
    SSR     = SSR + sub_ssr;
end

end